/*  Fichier qui permet l'quilibrage des comptes */
/*     equilibrage.c */


/*     Copyright (C) 2000-2001  Cdric Auger */
/* 			cedric@grisbi.org */
/* 			http://www.grisbi.org */

/*     This program is free software; you can redistribute it and/or modify */
/*     it under the terms of the GNU General Public License as published by */
/*     the Free Software Foundation; either version 2 of the License, or */
/*     (at your option) any later version. */

/*     This program is distributed in the hope that it will be useful, */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*     GNU General Public License for more details. */

/*     You should have received a copy of the GNU General Public License */
/*     along with this program; if not, write to the Free Software */
/*     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */


#include "include.h"
#include "structures.h"
#include "variables-extern.c"
#include "en_tete.h"




/* ********************************************************************************************************** */
GtkWidget *creation_fenetre_equilibrage ( void )
{
  GtkWidget *fenetre_equilibrage;
  GtkWidget *label;
  GtkWidget *table;
  GtkWidget *hbox;
  GtkWidget *bouton;  
  GtkWidget *separateur;
  GtkTooltips *tips;


  /* la fenetre est une vbox */

  fenetre_equilibrage = gtk_vbox_new ( FALSE, 5 );
  gtk_container_set_border_width ( GTK_CONTAINER ( fenetre_equilibrage ),
				   10 );
  gtk_widget_show ( fenetre_equilibrage );


  /* on met le nom du compte  quilibrer en haut */
 
  label_equilibrage_compte = gtk_label_new ( "" );
  gtk_label_set_justify ( GTK_LABEL (label_equilibrage_compte ),
			  GTK_JUSTIFY_CENTER);
  gtk_box_pack_start ( GTK_BOX ( fenetre_equilibrage ),
		       label_equilibrage_compte,
		       FALSE,
		       FALSE,
		       0);
  gtk_widget_show ( label_equilibrage_compte );


  separateur = gtk_hseparator_new();
  gtk_box_pack_start ( GTK_BOX ( fenetre_equilibrage ),
		       separateur,
		       FALSE,
		       FALSE,
		       0);
  gtk_widget_show ( separateur );


  /* on cre le tooltips */

  tips = gtk_tooltips_new ();

  /*   sous le nom, on met le no de rapprochement, c'est une entre car il est modifiable */

  hbox = gtk_hbox_new ( FALSE,
			5 );
  gtk_box_pack_start ( GTK_BOX ( fenetre_equilibrage ),
		       hbox,
		       FALSE,
		       FALSE,
		       10);
  gtk_widget_show ( hbox );

  label = gtk_label_new ( "N de rapprochement :" );
  gtk_box_pack_start ( GTK_BOX ( hbox ),
		       label,
		       FALSE,
		       FALSE,
		       0);
  gtk_widget_show ( label );

  entree_no_rapprochement = gtk_entry_new ();
  gtk_widget_set_usize ( entree_no_rapprochement,
			 50,
			 FALSE );
  gtk_tooltips_set_tip ( GTK_TOOLTIPS ( tips ),
			 entree_no_rapprochement,
			 "Si le n de rapprochement est termin par un chiffre, celui-ci est automatiquement incrment  chaque nouveau rapprochement.",
			 "Numro de rapprochement" );
  gtk_box_pack_start ( GTK_BOX ( hbox ),
		       entree_no_rapprochement,
		       FALSE,
		       FALSE,
		       0);
  gtk_widget_show ( entree_no_rapprochement );


  separateur = gtk_hseparator_new();
  gtk_box_pack_start ( GTK_BOX ( fenetre_equilibrage ),
		       separateur,
		       FALSE,
		       FALSE,
		       0);
  gtk_widget_show ( separateur );




  /* on met un premier tab en haut contenant dates et soldes des relevs avec possibilit de modif */
  /* du courant */

  table = gtk_table_new ( 3,
			  5,
			  FALSE );
  gtk_table_set_row_spacings ( GTK_TABLE ( table ),
			       5 );
  gtk_box_pack_start ( GTK_BOX ( fenetre_equilibrage ),
		       table,
		       FALSE,
		       FALSE,
		       0);
  gtk_widget_show ( table );


  separateur = gtk_hseparator_new();
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      separateur,
			      0, 3,
			      1, 2 );
  gtk_widget_show ( separateur );


  separateur = gtk_hseparator_new();
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      separateur,
			      0, 3,
			      3, 4 );
  gtk_widget_show ( separateur );


  separateur = gtk_vseparator_new ();
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      separateur,
			      1, 2,
			      0, 5 );
  gtk_widget_show ( separateur );



  label = gtk_label_new ( "Date" );
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      label,
			      0, 1,
			      0, 1);
  gtk_widget_show ( label );


  label = gtk_label_new ( "Solde" );
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      label,
			      2, 3,
			      0, 1);
  gtk_widget_show ( label );



  label_ancienne_date_equilibrage = gtk_label_new ( "" );
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      label_ancienne_date_equilibrage,
			      0, 1,
			      2, 3 );
  gtk_widget_show ( label_ancienne_date_equilibrage );


  entree_ancien_solde_equilibrage = gtk_entry_new ( );
  gtk_widget_set_usize ( entree_ancien_solde_equilibrage,
			 50,
			 FALSE );
  gtk_signal_connect ( GTK_OBJECT ( entree_ancien_solde_equilibrage ),
		       "changed",
		       GTK_SIGNAL_FUNC ( modif_entree_solde_init_equilibrage ),
		       NULL );
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      entree_ancien_solde_equilibrage,
			      2, 3,
			      2, 3 );
  gtk_widget_show ( entree_ancien_solde_equilibrage );



  entree_nouvelle_date_equilibrage = gtk_entry_new ();
  gtk_widget_set_usize ( entree_nouvelle_date_equilibrage,
			 50,
			 FALSE );
  gtk_signal_connect_after ( GTK_OBJECT ( entree_nouvelle_date_equilibrage ),
		       "focus-out-event",
		       GTK_SIGNAL_FUNC ( sortie_entree_date_equilibrage ),
		       NULL );
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      entree_nouvelle_date_equilibrage,
			      0, 1,
			      4, 5 );
  gtk_widget_show ( entree_nouvelle_date_equilibrage );


  entree_nouveau_montant_equilibrage = gtk_entry_new ();
  gtk_widget_set_usize ( entree_nouveau_montant_equilibrage,
			 50,
			 FALSE );
  gtk_signal_connect ( GTK_OBJECT ( entree_nouveau_montant_equilibrage ),
		       "changed",
		       GTK_SIGNAL_FUNC ( modif_entree_solde_final_equilibrage ),
		       NULL );
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      entree_nouveau_montant_equilibrage,
			      2, 3,
			      4, 5 );
  gtk_widget_show ( entree_nouveau_montant_equilibrage );




  separateur = gtk_hseparator_new();
  gtk_box_pack_start ( GTK_BOX ( fenetre_equilibrage ),
		       separateur,
		       FALSE,
		       FALSE,
		       0);
  gtk_widget_show ( separateur );


  /*   la 2me table contient le solde init, final, du pointage et l'cart */

  table = gtk_table_new ( 5,
				      2,
				      FALSE );
  gtk_table_set_row_spacings ( GTK_TABLE ( table ),
			       5 );
  gtk_box_pack_start ( GTK_BOX ( fenetre_equilibrage ),
		       table,
		       FALSE,
		       FALSE,
		       15);
  gtk_widget_show ( table );



  label = gtk_label_new ( "Solde initial : " );
  gtk_misc_set_alignment ( GTK_MISC ( label ),
			   0,
			   0.5 );
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      label,
			      0, 1,
			      0, 1);
  gtk_widget_show ( label );


  label_equilibrage_initial = gtk_label_new ( "" );
  gtk_misc_set_alignment ( GTK_MISC ( label_equilibrage_initial ),
			   1,
			   0.5 );
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      label_equilibrage_initial,
			      1, 2,
			      0, 1);
  gtk_widget_show ( label_equilibrage_initial );


  label = gtk_label_new ( "Solde final : " );
  gtk_misc_set_alignment ( GTK_MISC ( label ),
			   0,
			   0.5 );
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      label,
			      0, 1,
			      1, 2);
  gtk_widget_show ( label );


  label_equilibrage_final = gtk_label_new ( "" );
  gtk_misc_set_alignment ( GTK_MISC ( label_equilibrage_final ),
			   1,
			   0.5 );
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      label_equilibrage_final,
			      1, 2,
			      1, 2);
  gtk_widget_show ( label_equilibrage_final );


  label = gtk_label_new ( "Pointage : " );
  gtk_misc_set_alignment ( GTK_MISC ( label ),
			   0,
			   0.5 );
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      label,
			      0, 1,
			      2, 3);
  gtk_widget_show ( label );

  label_equilibrage_pointe = gtk_label_new ( "" );
  gtk_misc_set_alignment ( GTK_MISC ( label_equilibrage_pointe ),
			   1,
			   0.5 );
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      label_equilibrage_pointe,
			      1, 2,
			      2, 3);
  gtk_widget_show ( label_equilibrage_pointe );


  separateur = gtk_hseparator_new();
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      separateur,
			      0, 2,
			      3, 4);
  gtk_widget_show ( separateur );


  label = gtk_label_new ( "cart : " );
  gtk_misc_set_alignment ( GTK_MISC ( label ),
			   0,
			   0.5 );
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      label,
			      0, 1,
			      4, 5);
  gtk_widget_show ( label );


  label_equilibrage_ecart = gtk_label_new ( "" );
  gtk_misc_set_alignment ( GTK_MISC ( label_equilibrage_ecart ),
			   1,
			   0.5 );
  gtk_table_attach_defaults ( GTK_TABLE ( table ),
			      label_equilibrage_ecart,
			      1, 2,
			      4, 5);
  gtk_widget_show ( label_equilibrage_ecart );



/* on met les boutons */


  hbox = gtk_hbox_new ( TRUE,
					    5);
  gtk_box_pack_end ( GTK_BOX ( fenetre_equilibrage ),
		       hbox,
		       FALSE,
		       FALSE,
		       0);
  gtk_widget_show ( hbox );
  
  bouton_ok_equilibrage = gtk_button_new_with_label (" Valider  " );
  gtk_button_set_relief ( GTK_BUTTON ( bouton_ok_equilibrage),
			  GTK_RELIEF_NONE);
  gtk_signal_connect (GTK_OBJECT (bouton_ok_equilibrage),
		      "clicked",
		      (GtkSignalFunc) fin_equilibrage,
		      NULL );
  gtk_box_pack_start ( GTK_BOX ( hbox ),
		       bouton_ok_equilibrage,
		       FALSE,
		       FALSE,
		       0);
  gtk_widget_show ( bouton_ok_equilibrage );

  
  bouton = gtk_button_new_with_label (" Annuler  " );
  gtk_button_set_relief ( GTK_BUTTON ( bouton),
			  GTK_RELIEF_NONE);
  gtk_signal_connect ( GTK_OBJECT (bouton),
		       "clicked",
		       (GtkSignalFunc) annuler_equilibrage,
		       NULL );
  gtk_box_pack_start ( GTK_BOX ( hbox ),
		       bouton,
		       FALSE,
		       FALSE,
		       0);
  gtk_widget_show ( bouton );


  separateur = gtk_hseparator_new();
  gtk_box_pack_end ( GTK_BOX ( fenetre_equilibrage ),
		       separateur,
		       FALSE,
		       FALSE,
		       0);
  gtk_widget_show ( separateur );


  return ( fenetre_equilibrage );
}
/* ********************************************************************************************************** */





/* ********************************************************************************************************** */
void equilibrage ( void )
{
  GDate *date;
  GSList *pointeur_liste_ope;
  struct struct_devise *devise_compte;
  struct struct_devise *devise_operation;

  p_tab_nom_de_compte_variable = p_tab_nom_de_compte_courant;

  if ( !NB_OPE_COMPTE )
    {
      dialogue ( " Il n'y a aucune oprations dans ce compte   " );
      return;
    }


  /* efface le label proprits du compte */

  gtk_widget_hide ( label_proprietes_operations_compte );

  /* rcupre l'adr de la devise du compte */

  devise_compte = g_slist_find_custom ( liste_struct_devises,
					GINT_TO_POINTER ( DEVISE ),
					( GCompareFunc ) recherche_devise_par_no) -> data;

  /* calcule le montant des oprations pointes */

  pointeur_liste_ope = LISTE_OPERATIONS;
  operations_pointees = 0;

  while ( pointeur_liste_ope )
    {
      struct structure_operation *operation;

      operation = pointeur_liste_ope -> data;

      if ( operation -> pointe == 1 )
	{
	  gdouble montant;

	  if ( operation -> devise == DEVISE )
	    montant = operation -> montant;
	  else
	    {
	      /* ce n'est pas la devise du compte, si le compte passe  l'euro et que la devise est l'euro, utilise la conversion du compte, */
	      /* si c'est une devise qui passe  l'euro et que la devise du compte est l'euro, utilise la conversion du compte */
	      /* sinon utilise la conversion stocke dans l'op */
	      
	      devise_operation = g_slist_find_custom ( liste_struct_devises,
						       GINT_TO_POINTER ( operation -> devise ),
						       ( GCompareFunc ) recherche_devise_par_no ) -> data;
	      
	      if ( devise_compte -> passage_euro
		   &&
		   !strcmp ( devise_operation -> nom_devise, "Euro" ) )
		montant = operation -> montant * devise_compte -> change;
	      else
		if ( devise_operation -> passage_euro
		     &&
		     !strcmp ( devise_compte -> nom_devise, "Euro" ))
		  montant = operation -> montant / devise_operation -> change;
		else
		  if ( operation -> une_devise_compte_egale_x_devise_ope )
		    montant = operation -> montant / operation -> taux_change - operation -> frais_change;
		  else
		    montant = operation -> montant * operation -> taux_change - operation -> frais_change;

	      montant = ( rint (montant * 100 )) / 100;
	    }
	  operations_pointees = operations_pointees + montant;
	}

      pointeur_liste_ope = pointeur_liste_ope -> next;
    }

  gtk_label_set_text ( GTK_LABEL ( label_equilibrage_pointe ),
		       g_strdup_printf ( "%4.2f", 
					 operations_pointees ));


  /* rcupre l'ancien no de rapprochement et essaie d'augmenter la partie numrique */
  /*   si ne russit pas, remet juste le nom de l'ancien */

  if ( DERNIER_NO_RAPPROCHEMENT )
    {
      GSList *liste_tmp;

      liste_tmp = g_slist_find_custom ( liste_no_rapprochements,
					GINT_TO_POINTER ( DERNIER_NO_RAPPROCHEMENT ),
					(GCompareFunc) recherche_no_rapprochement_par_no );

      if ( liste_tmp )
	{
	  struct struct_no_rapprochement *rapprochement;
	  gchar *pointeur_mobile;
	  gchar *pointeur_fin;
	  gchar *new_rap;

	  rapprochement = liste_tmp -> data;


	  /* on va crer une nouvelle chaine contenant la partie numrique */

	  new_rap = g_strdup ( rapprochement -> nom_rapprochement );
	  pointeur_fin = new_rap + (strlen ( new_rap ) - 1) * sizeof (gchar);
	  pointeur_mobile = pointeur_fin;

	  while ( pointeur_mobile[0] > 47 && pointeur_mobile[0] < 58 && pointeur_mobile >= new_rap )
	    pointeur_mobile--;

	  if ( pointeur_mobile != pointeur_fin )
	    {
	      /* la fin du no de rapprochement est numrique */

	      gchar *partie_num;

	      pointeur_mobile++;

	      partie_num = g_strdup ( pointeur_mobile );
	      pointeur_mobile[0] = 0;

	      /* on incrmente la partie numrique */

	      partie_num = itoa ( atoi ( partie_num ) + 1 );

	      /* on  remet le tout ensemble */

	      new_rap = g_strconcat ( new_rap,
				      partie_num,
				      NULL );
	    }
	  else
	    new_rap = rapprochement -> nom_rapprochement;

	  gtk_entry_set_text ( GTK_ENTRY ( entree_no_rapprochement ),
			       new_rap );

	}
    }
  else
    gtk_entry_set_text ( GTK_ENTRY ( entree_no_rapprochement ),
			 "" );

  /* rcupre l'ancienne date et l'augmente d'1 mois et le met dans entree_nouvelle_date_equilibrage */

  if ( DATE_DERNIER_RELEVE )
    {
      date = g_date_new_dmy ( g_date_day ( DATE_DERNIER_RELEVE ),
			      g_date_month ( DATE_DERNIER_RELEVE ),
			      g_date_year ( DATE_DERNIER_RELEVE ));

      gtk_label_set_text ( GTK_LABEL ( label_ancienne_date_equilibrage ),
			   g_strdup_printf ( "%02d/%02d/%d", 
					     g_date_day ( date ),
					     g_date_month ( date ),
					     g_date_year ( date ) ));
      g_date_add_months ( date,
			  1 );

      gtk_entry_set_text ( GTK_ENTRY ( entree_ancien_solde_equilibrage ),
			   g_strdup_printf ("%4.2f", SOLDE_DERNIER_RELEVE ));
      gtk_widget_set_sensitive ( GTK_WIDGET ( entree_ancien_solde_equilibrage ),
				 FALSE );
    }
  else
    {
      time_t today;

      gtk_label_set_text ( GTK_LABEL ( label_ancienne_date_equilibrage ),
			   "Aucune" );

      time ( &today );
      date = g_date_new_dmy ( gmtime ( &today ) -> tm_mday,
			      gmtime ( &today ) -> tm_mon + 1,
			      gmtime ( &today ) -> tm_year + 1900 );

      gtk_entry_set_text ( GTK_ENTRY ( entree_ancien_solde_equilibrage ),
			   g_strdup_printf ("%4.2f", SOLDE_INIT ));
      gtk_widget_set_sensitive ( GTK_WIDGET ( entree_ancien_solde_equilibrage ),
				 TRUE );
    }



  gtk_entry_set_text ( GTK_ENTRY ( entree_nouvelle_date_equilibrage ),
		       g_strdup_printf ( "%02d/%02d/%d", 
					 g_date_day ( date ),
					 g_date_month ( date ),
					 g_date_year ( date ) ));



  gtk_entry_set_text ( GTK_ENTRY ( entree_nouveau_montant_equilibrage ),
		       "" );

  gtk_label_set_text ( GTK_LABEL ( label_equilibrage_compte ),
		       NOM_DU_COMPTE );


  etat.equilibrage = 1;

  if ( solde_final - solde_initial - operations_pointees )
    gtk_widget_set_sensitive ( bouton_ok_equilibrage,
			       FALSE );
  else
    gtk_widget_set_sensitive ( bouton_ok_equilibrage,
			       TRUE );


  /* affiche la liste en op simplifies */

  ancien_nb_lignes_ope = nb_lignes_ope;

  if ( nb_lignes_ope != 1 )
    gtk_button_clicked ( GTK_BUTTON ( bouton_ope_simples ));


  /* classe la liste des ops en fonction des types ou non */

  if ( TRI
       &&
       LISTE_TRI )
    gtk_clist_set_compare_func ( GTK_CLIST ( CLIST_OPERATIONS ),
				 (GtkCListCompareFunc) classement_liste_par_tri_courant );


  remplissage_liste_operations ( compte_courant );

  gtk_notebook_set_page ( GTK_NOTEBOOK ( notebook_comptes_equilibrage ),
			  2 );


  /* la liste des op prend le focus */

  gtk_widget_grab_focus ( GTK_WIDGET ( CLIST_OPERATIONS ));
}
/* ********************************************************************************************************** */



/* ********************************************************************************************************** */
void sortie_entree_date_equilibrage ( void )
{
  gchar *text;
  gint nb_parametres;
  GDate *date;
  gint date_releve_jour;
  gint date_releve_mois;
  gint date_releve_annee;


  text = gtk_entry_get_text ( GTK_ENTRY ( entree_nouvelle_date_equilibrage ) );

  if ( ( nb_parametres = sscanf ( text,
				  "%d/%d/%d",
				  &date_releve_jour,
				  &date_releve_mois,
				  &date_releve_annee))
       != 3 )
    {
      if ( !nb_parametres || nb_parametres == -1 )
	return;


      date = g_date_new ();
      g_date_set_time ( date,
			time(NULL));

      if ( nb_parametres == 1)
	date_releve_mois = g_date_month (date);

      date_releve_annee = g_date_year (date);

    }

  if ( g_date_valid_dmy ( date_releve_jour,
			  date_releve_mois,
			  date_releve_annee)
       == FALSE )
    {
      dialogue ( "Erreur : date invalide" );
      return;
    };


  gtk_entry_set_text ( GTK_ENTRY ( entree_nouvelle_date_equilibrage ),
		       g_strdup_printf ( "%02d/%02d/%d", 
					 date_releve_jour,
					 date_releve_mois,
					 date_releve_annee ) );
	   




}
/* ********************************************************************************************************** */

				      
/* ********************************************************************************************************** */
void modif_entree_solde_init_equilibrage ( void )
{

  gtk_label_set_text ( GTK_LABEL ( label_equilibrage_initial ),
		       gtk_entry_get_text ( GTK_ENTRY ( entree_ancien_solde_equilibrage )) );

  solde_initial = g_strtod ( gtk_entry_get_text ( GTK_ENTRY ( entree_ancien_solde_equilibrage )),
			     NULL );


  if ( fabs ( solde_final - solde_initial - operations_pointees ) < 0.01 )
    {
      gtk_label_set_text ( GTK_LABEL ( label_equilibrage_ecart ),
			   g_strdup_printf ( "%4.2f",
					     0.0 ));
      gtk_widget_set_sensitive ( GTK_WIDGET ( bouton_ok_equilibrage ),
				 TRUE );
    }
  else
    {
      gtk_label_set_text ( GTK_LABEL ( label_equilibrage_ecart ),
			   g_strdup_printf ( "%4.2f",
					     solde_final - solde_initial - operations_pointees ));
      gtk_widget_set_sensitive ( GTK_WIDGET ( bouton_ok_equilibrage ),
				 FALSE );
    }

}
/* ********************************************************************************************************** */





				      
/* ********************************************************************************************************** */
void modif_entree_solde_final_equilibrage ( void )
{


  gtk_label_set_text ( GTK_LABEL ( label_equilibrage_final ),
		       gtk_entry_get_text ( GTK_ENTRY ( entree_nouveau_montant_equilibrage )) );

  solde_final = g_strtod ( gtk_entry_get_text ( GTK_ENTRY ( entree_nouveau_montant_equilibrage )),
			   NULL );

  if ( fabs ( solde_final - solde_initial - operations_pointees ) < 0.01 )
    {
      gtk_label_set_text ( GTK_LABEL ( label_equilibrage_ecart ),
			   g_strdup_printf ( "%4.2f",
					     0.0 ));
      gtk_widget_set_sensitive ( GTK_WIDGET ( bouton_ok_equilibrage ),
				 TRUE );
    }
  else
    {
      gtk_label_set_text ( GTK_LABEL ( label_equilibrage_ecart ),
			   g_strdup_printf ( "%4.2f",
					     solde_final - solde_initial - operations_pointees ));
      gtk_widget_set_sensitive ( GTK_WIDGET ( bouton_ok_equilibrage ),
				 FALSE );
    }

}
/* ********************************************************************************************************** */







/* ********************************************************************************************************** */
/* on annule l'quilibrage */
/* ********************************************************************************************************** */

void annuler_equilibrage ( GtkWidget *bouton_ann,
			   gpointer data)
{

  gtk_notebook_set_page ( GTK_NOTEBOOK ( notebook_comptes_equilibrage ),
			  0 );

  etat.equilibrage = 0;

  if ( ancien_nb_lignes_ope != nb_lignes_ope )
    {
      if ( ancien_nb_lignes_ope == 4 )
	gtk_button_clicked ( GTK_BUTTON ( bouton_ope_completes ));
      else
	gtk_button_clicked ( GTK_BUTTON ( bouton_ope_semi_completes ));
    }
	

  p_tab_nom_de_compte_variable = p_tab_nom_de_compte_courant;

  gtk_clist_set_compare_func ( GTK_CLIST ( CLIST_OPERATIONS ),
			       (GtkCListCompareFunc) classement_liste_par_date );

  remplissage_liste_operations ( compte_courant );

  gtk_widget_show ( label_proprietes_operations_compte );

  focus_a_la_liste ();
}
/* ********************************************************************************************************** */





/* ********************************************************************************************************** */
/* fonction appele quand il y a un click dans la colonne des P, et si l'quilibrage */
/* est en cours */
/* ********************************************************************************************************** */

void pointe_equilibrage ( int p_ligne )
{
  struct structure_operation *operation;
  struct struct_devise *devise_compte;
  struct struct_devise *devise_operation;
  gdouble montant;

  operation = gtk_clist_get_row_data ( GTK_CLIST ( CLIST_OPERATIONS ),
				       p_ligne );


  if ( operation == GINT_TO_POINTER ( -1 ) )
    return;


  if ( operation -> pointe == 2 )
    return;


  p_tab_nom_de_compte_variable = p_tab_nom_de_compte_courant;

  /* rcupre l'adr de la devise du compte */

  devise_compte = g_slist_find_custom ( liste_struct_devises,
					GINT_TO_POINTER ( DEVISE ),
					( GCompareFunc ) recherche_devise_par_no) -> data;

  if ( operation -> pointe )
    {
      if ( operation -> devise == DEVISE )
	montant = operation -> montant;
      else
	{
	  /* ce n'est pas la devise du compte, si le compte passe  l'euro et que la devise est l'euro, utilise la conversion du compte, */
	  /* si c'est une devise qui passe  l'euro et que la devise du compte est l'euro, utilise la conversion du compte */
	  /* sinon utilise la conversion stocke dans l'op */
	      
	  devise_operation = g_slist_find_custom ( liste_struct_devises,
						   GINT_TO_POINTER ( operation -> devise ),
						   ( GCompareFunc ) recherche_devise_par_no ) -> data;
	      
	  if ( devise_compte -> passage_euro
	       &&
	       !strcmp ( devise_operation -> nom_devise, "Euro" ) )
	    montant = operation -> montant * devise_compte -> change;
	  else
	    if ( devise_operation -> passage_euro
		 &&
		 !strcmp ( devise_compte -> nom_devise, "Euro" ))
	     montant  = operation -> montant / devise_operation -> change;
	    else
	      if ( operation -> une_devise_compte_egale_x_devise_ope )
		montant = operation -> montant / operation -> taux_change + operation -> frais_change;
	      else
		montant = operation -> montant * operation -> taux_change + operation -> frais_change;

	  montant = ( rint (montant * 100 )) / 100;
	}

      operations_pointees = operations_pointees - montant;
      SOLDE_POINTE = SOLDE_POINTE - montant;

      operation -> pointe = 0;

      gtk_clist_set_text ( GTK_CLIST ( CLIST_OPERATIONS ),
			   p_ligne,
			   3,
			   " ");
    }
  else
    {
      if ( operation -> devise == DEVISE )
	montant = operation -> montant;
      else
	{
	  /* ce n'est pas la devise du compte, si le compte passe  l'euro et que la devise est l'euro, utilise la conversion du compte, */
	  /* si c'est une devise qui passe  l'euro et que la devise du compte est l'euro, utilise la conversion du compte */
	  /* sinon utilise la conversion stocke dans l'op */
	      
	  devise_operation = g_slist_find_custom ( liste_struct_devises,
						   GINT_TO_POINTER ( operation -> devise ),
						   ( GCompareFunc ) recherche_devise_par_no ) -> data;
	      
	  if ( devise_compte -> passage_euro
	       &&
	       !strcmp ( devise_operation -> nom_devise, "Euro" ) )
	   montant  = operation -> montant * devise_compte -> change;
	  else
	    if ( devise_operation -> passage_euro
		 &&
		 !strcmp ( devise_compte -> nom_devise, "Euro" ))
	      montant = operation -> montant / devise_operation -> change;
	    else
	      if ( operation -> une_devise_compte_egale_x_devise_ope )
		montant = operation -> montant / operation -> taux_change - operation -> frais_change;
	      else
		montant = operation -> montant * operation -> taux_change - operation -> frais_change;
	  montant = ( rint (montant * 100 )) / 100;

	}

      operations_pointees = operations_pointees + montant;
      SOLDE_POINTE = SOLDE_POINTE + montant;

      operation -> pointe = 1;

      gtk_clist_set_text ( GTK_CLIST ( CLIST_OPERATIONS ),
			   p_ligne,
			   3,
			   "P");
    }

    

  gtk_label_set_text ( GTK_LABEL ( label_equilibrage_pointe ),
		       g_strdup_printf ("%4.2f",
					operations_pointees ));

  if ( fabs ( solde_final - solde_initial - operations_pointees ) < 0.01 )
    {
      gtk_label_set_text ( GTK_LABEL ( label_equilibrage_ecart ),
			   g_strdup_printf ( "%4.2f",
					     0.0 ));
      gtk_widget_set_sensitive ( GTK_WIDGET ( bouton_ok_equilibrage ),
				 TRUE );
    }
  else
    {
      gtk_label_set_text ( GTK_LABEL ( label_equilibrage_ecart ),
			   g_strdup_printf ( "%4.2f",
					     solde_final - solde_initial - operations_pointees ));
      gtk_widget_set_sensitive ( GTK_WIDGET ( bouton_ok_equilibrage ),
				 FALSE );
    }

  /* met le label du solde point */

  gtk_label_set_text ( GTK_LABEL ( solde_label_pointe ),
		       g_strdup_printf ( " Solde point : %4.2f %s",
					 SOLDE_POINTE,
					 ((struct struct_devise *)(g_slist_find_custom ( liste_struct_devises,
											 GINT_TO_POINTER ( DEVISE ),
											 (GCompareFunc) recherche_devise_par_no )-> data )) -> code_devise) );

  modification_fichier( TRUE );

}
/* ********************************************************************************************************** */




/* ********************************************************************************************************** */
void fin_equilibrage ( GtkWidget *bouton_ok,
		       gpointer data )
{
  GSList *pointeur_liste_ope;
  gchar *text;
  gint nb_parametres;
  GDate *date;
  gint date_releve_jour;
  gint date_releve_mois;
  gint date_releve_annee;


  if ( fabs ( solde_final - solde_initial - operations_pointees ) >= 0.01 )
    {
      dialogue ( " L'cart n'est pas de zro  ");
      return;
    }


  p_tab_nom_de_compte_variable = p_tab_nom_de_compte_courant;


  /* rcupration de la date */

  text = gtk_entry_get_text ( GTK_ENTRY ( entree_nouvelle_date_equilibrage ) );

  if ( ( nb_parametres = sscanf ( text,
				  "%d/%d/%d",
				  &date_releve_jour,
				  &date_releve_mois,
				  &date_releve_annee))
       != 3 )
    {
      if ( !nb_parametres || nb_parametres == -1 )
    {
      dialogue ( "Erreur : date invalide" );
      return;
    }


      date = g_date_new ();
      g_date_set_time ( date,
			time(NULL));

      if ( nb_parametres == 1)
	date_releve_mois = g_date_month(date);

      date_releve_annee = g_date_year(date);

    }

  if ( !g_date_valid_dmy ( date_releve_jour,
			   date_releve_mois,
			   date_releve_annee))
    {
      dialogue ( "Erreur : date invalide" );
      return;
    }

  DATE_DERNIER_RELEVE = g_date_new_dmy ( date_releve_jour,
					 date_releve_mois,
					 date_releve_annee );

  gtk_label_set_text ( GTK_LABEL ( label_releve ),
		       g_strdup_printf ( "Dernier relev : %02d/%02d/%d", 
					 date_releve_jour,
					 date_releve_mois,
					 date_releve_annee ));


  /*   rcupration du no de rapprochement, */
  /*     s'il n'existe pas,on le cre */

  if ( strlen ( g_strstrip ( gtk_entry_get_text ( GTK_ENTRY ( entree_no_rapprochement )))))
    {
      struct struct_no_rapprochement *rapprochement;
      GSList *liste_tmp;
      gchar *rap_txt;

      rap_txt = g_strstrip ( gtk_entry_get_text ( GTK_ENTRY ( entree_no_rapprochement )));

      liste_tmp = g_slist_find_custom ( liste_no_rapprochements,
					rap_txt,
					(GCompareFunc) recherche_no_rapprochement_par_nom );

      if ( liste_tmp )
	{
	  /* le rapprochement existe dj */

	  rapprochement = liste_tmp -> data;
	  DERNIER_NO_RAPPROCHEMENT = rapprochement -> no_rapprochement;
	}
      else
	{
	  /* le rapprochement n'existe pas */

	  rapprochement = malloc ( sizeof ( struct struct_no_rapprochement ));
	  rapprochement -> no_rapprochement = g_slist_length ( liste_no_rapprochements ) + 1;
	  rapprochement -> nom_rapprochement = g_strdup ( rap_txt );

	  liste_no_rapprochements = g_slist_append ( liste_no_rapprochements,
						     rapprochement );

	  DERNIER_NO_RAPPROCHEMENT = rapprochement -> no_rapprochement;
	}
    }
  else
    DERNIER_NO_RAPPROCHEMENT = 0;



/* met tous les P  R */

  p_tab_nom_de_compte_variable = p_tab_nom_de_compte_courant;

  pointeur_liste_ope = LISTE_OPERATIONS;

  while ( pointeur_liste_ope )
    {
      struct structure_operation *operation;

      operation = pointeur_liste_ope -> data;

      if ( operation -> pointe == 1 )
	{
	  operation -> pointe = 2;
	  operation -> no_rapprochement = DERNIER_NO_RAPPROCHEMENT;
	}

      pointeur_liste_ope = pointeur_liste_ope -> next;
    }



/* on raffiche la liste */

  modification_fichier( TRUE );

  SOLDE_DERNIER_RELEVE = solde_final;


  gtk_notebook_set_page ( GTK_NOTEBOOK ( notebook_comptes_equilibrage ),
			  0 );

  etat.equilibrage = 0;

  if ( ancien_nb_lignes_ope != nb_lignes_ope )
    {
      if ( ancien_nb_lignes_ope == 4 )
	gtk_button_clicked ( GTK_BUTTON ( bouton_ope_completes ));
      else
	gtk_button_clicked ( GTK_BUTTON ( bouton_ope_semi_completes ));
    }
	
  gtk_clist_set_compare_func ( GTK_CLIST ( CLIST_OPERATIONS ),
			       (GtkCListCompareFunc) classement_liste_par_date );


  remplissage_liste_operations ( compte_courant );

  gtk_widget_show ( label_proprietes_operations_compte );

/*   on redonne le focus  la liste */

  gtk_widget_grab_focus ( GTK_WIDGET ( CLIST_OPERATIONS ) );
}
/* ********************************************************************************************************** */


/* ********************************************************************************************************** */
gint recherche_no_rapprochement_par_nom ( struct struct_no_rapprochement *rapprochement,
					  gchar *no_rap )
{

  return ( strcmp ( rapprochement -> nom_rapprochement,
		    no_rap ));

}
/* ********************************************************************************************************** */


/* ********************************************************************************************************** */
gint recherche_no_rapprochement_par_no ( struct struct_no_rapprochement *rapprochement,
					 gint *no_rap )
{

  return ( !(rapprochement -> no_rapprochement == GPOINTER_TO_INT ( no_rap )));

}
/* ********************************************************************************************************** */
