/* ce fichier de la gestion du format qif */


/*     Copyright (C) 2000-2001  Cdric Auger */
/* 			cedric@grisbi.org */
/* 			http://www.grisbi.org */

/*     This program is free software; you can redistribute it and/or modify */
/*     it under the terms of the GNU General Public License as published by */
/*     the Free Software Foundation; either version 2 of the License, or */
/*     (at your option) any later version. */

/*     This program is distributed in the hope that it will be useful, */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*     GNU General Public License for more details. */

/*     You should have received a copy of the GNU General Public License */
/*     along with this program; if not, write to the Free Software */
/*     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */



#include "include.h"
#include "structures.h"
#include "variables-extern.c"
#include "en_tete.h"



/* *******************************************************************************/
/* fonction importer_fichier_qif */
/* appele par le menu importer */
/* *******************************************************************************/

void importer_fichier_qif ( void )
{
  liste_comptes_qif = NULL;

  selection_fichier_qif ();
}
/* *******************************************************************************/



/* *******************************************************************************/
/* Affiche la fentre de slection de fichier */
/* *******************************************************************************/

void selection_fichier_qif ( void )
{
  GtkWidget *fenetre;


  fenetre = gtk_file_selection_new ( "Slection d'un fichier QIF" );
  gtk_window_set_transient_for ( GTK_WINDOW ( fenetre ),
				 GTK_WINDOW ( window ));
  gtk_window_set_modal ( GTK_WINDOW ( fenetre ),
			 TRUE );
  gtk_clist_set_selection_mode ( GTK_CLIST ( GTK_FILE_SELECTION( fenetre ) -> file_list ),
				 GTK_SELECTION_EXTENDED );
  gtk_file_selection_set_filename ( GTK_FILE_SELECTION ( fenetre ),
				    dernier_chemin_de_travail );

  gtk_signal_connect_object (GTK_OBJECT ( GTK_FILE_SELECTION( fenetre ) -> ok_button ),
			     "clicked",
			     GTK_SIGNAL_FUNC ( fichier_choisi_importation_qif ),
			     GTK_OBJECT ( fenetre ));
  gtk_signal_connect_object (GTK_OBJECT ( GTK_FILE_SELECTION( fenetre ) -> cancel_button ),
			     "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT ( fenetre ));
  gtk_signal_connect ( GTK_OBJECT ( fenetre ),
		       "destroy",
		       GTK_SIGNAL_FUNC ( traitement_donnees_brutes ),
		       NULL );
  gtk_widget_show ( fenetre );


}
/* *******************************************************************************/





/* *******************************************************************************/
void fichier_choisi_importation_qif ( GtkWidget *fenetre )
{
  gchar *nom_fichier_qif;
  FILE *fichier_qif;
  gchar *pointeur_char;
  gchar **tab_char;
  struct donnees_compte *compte;
  GSList *liste_ope_brut;
  gint retour;
  GList *selection;


  /* on met le rpertoire courant dans la variable correspondante */

  dernier_chemin_de_travail = g_strconcat ( GTK_LABEL ( GTK_BIN ( GTK_OPTION_MENU ( GTK_FILE_SELECTION ( fenetre ) -> history_pulldown )) -> child ) -> label,
					    "/",
					    NULL );

  /* on va rcuprer tous les fichiers slectionns puis proposer d'en importer d'autres */


  selection = GTK_CLIST ( GTK_FILE_SELECTION ( fenetre ) -> file_list ) -> selection;

  while ( selection )
    {
      gchar *fichier[1];
      gchar **separation;

      gtk_clist_get_text ( GTK_CLIST ( GTK_FILE_SELECTION ( fenetre ) -> file_list ),
			   GPOINTER_TO_INT ( selection -> data ),
			   0,
			   fichier );

      separation = g_strsplit ( GTK_LABEL ( GTK_FILE_SELECTION ( fenetre ) -> selection_text ) -> label,
				":",
				2 );

      nom_fichier_qif = g_strconcat ( g_strstrip ( separation[1] ),
				      "/",
				      fichier[0],
				      NULL );
      g_strfreev ( separation );


      if ( !( fichier_qif = fopen ( nom_fichier_qif,
				    "r" ) ))
	{
	  dialogue ( strerror ( errno ) );
	  return;
	}


      /* rcupration des donnes du compte */

      fscanf ( fichier_qif,
	       "%a[^\n]\n",
	       &pointeur_char );

      if ( strncmp ( pointeur_char,
		     "!Type",
		     5 )
	   &&
	   strncmp ( pointeur_char,
		     "!Account",
		     8 )
	   &&
	   strncmp ( pointeur_char,
		     "!Option",
		     7 ))
	{
	  dialogue ( g_strconcat ( "Le fichier ",
				   nom_fichier_qif,
				   " n'est pas un fichier QIF",
				   NULL ));
	  free ( pointeur_char );
	  return;
	}
      else
	gtk_signal_handler_block_by_func ( GTK_OBJECT ( fenetre ),
					   GTK_SIGNAL_FUNC ( traitement_donnees_brutes ),
					   NULL );


      /* c'est bien un fichier qif, on peut commencer */


      /* si a commence par !Option ou !Account ou !Type:Cat, on avance jusqu' ce qu'on */
      /* trouve un autre !Type */

    retour:
      if ( !strncmp ( pointeur_char,
		      "!Option",
		      7 )
	   ||
	   !strncmp ( pointeur_char,
		      "!Account",
		      8 )
	   ||
	   !strncmp ( pointeur_char,
		      "!Type:Cat",
		      9 ))
	{
	  do
	    {
	      fscanf ( fichier_qif,
		       "%a[^\n]\n",
		       &pointeur_char );
	    }
	  while ( strncmp ( pointeur_char,
			    "!Type",
			    5 ));
	  goto retour;
	}
	    

      /* rafraichit la fenetre d'attente */

      if ( patience_en_cours )
	while ( g_main_iteration ( FALSE ) );

      compte = calloc ( 1,
			sizeof ( struct donnees_compte ));


      /* ajoute ce compte aux autres comptes imports */
 
      liste_comptes_qif = g_slist_append ( liste_comptes_qif,
					   compte );


      /* rcupration du type de compte */

      tab_char = g_strsplit ( pointeur_char,
			      ":",
			      2 );

      if ( strcmp ( g_strstrip (tab_char[1]),
		    "Cash" ) )
	if ( strcmp ( g_strstrip ( tab_char[1]),
		      "Oth L" ))
	  compte -> type_de_compte = 0;
	else
	  compte -> type_de_compte = 2;
      else
	compte -> type_de_compte = 1;



      /* rcupre les autres donnes du compte */

      /*       pour un type CCard, le qif commence directement une op sans donner les */
      /* 	caractristiques de dpart du compte, on cre donc un compte du nom */
      /* "carte de crdit" avec un solde init de 0 */

      if ( strcmp ( g_strstrip (tab_char[1]),
		    "CCard" ))
	{
	  /* ce n'est pas une ccard, on rcupre les infos */

	  do
	    {
	      free ( pointeur_char );

	      retour = fscanf ( fichier_qif,
				"%a[^\n]\n",
				&pointeur_char );


	      /* rcupration du solde initial ( on doit virer la , que money met pour sparer les milliers ) */
	      /* on ne vire la , que s'il y a un . */

	      if ( pointeur_char[0] == 'T' )
		{
		  gchar **tab;

		  tab = g_strsplit ( pointeur_char,
				     ".",
				     2 );

		  if( tab[1] )
		    {
		      gchar **tab_char;

		      tab_char = g_strsplit ( pointeur_char,
					      ",",
					      FALSE );

		      pointeur_char = g_strjoinv ( NULL,
						   tab_char );
		      compte -> solde_initial = g_strtod ( pointeur_char + 1,
							   NULL );
		      g_strfreev ( tab_char );
		    }
		  else
		    compte -> solde_initial = g_strtod ( pointeur_char + 1,
							 NULL );

		  g_strfreev ( tab );

		}


	      /* rcupration du nom du compte */
	      /* 	      parfois, le nom est entre crochet et parfois non ... */

	      if ( pointeur_char[0] == 'L' )
		{
		  sscanf ( pointeur_char,
			   "L%a[^\n]",
			   &compte -> nom_de_compte );

		  /* on vire les crochets s'ils y sont */

		  compte -> nom_de_compte = g_strdelimit ( compte -> nom_de_compte,
							   "[",
							   ' ' );
		  compte -> nom_de_compte = g_strdelimit ( compte -> nom_de_compte,
							   "]",
							   ' ' );
		  compte -> nom_de_compte = g_strstrip ( compte -> nom_de_compte );

		}
	    }
	  while ( pointeur_char[0] != '^' && retour != EOF );
	}
      else
	{
	  /* c'est un compte ccard */

	  compte -> nom_de_compte = "Carte de crdit";
	  compte -> solde_initial = 0;
	  retour = 0;
	}



      if ( retour == EOF )
	{
	  dialogue ( "Le fichier ne contient aucune opration !" );
	  return;
	}

      /* rcupration des oprations en brut, on les traitera ensuite */

      liste_ope_brut = NULL;

      do
	{
	  struct struct_operation_qif *operation;
	  struct struct_operation_qif *ventilation;

	  ventilation = NULL;

	  operation = calloc ( 1,
			       sizeof ( struct struct_operation_qif ));

	  do
	    {
	      retour = fscanf ( fichier_qif,
				"%a[^\n]\n",
				&pointeur_char );

	      if ( retour != EOF )
		{
		  /* on vire le 0d  la fin de la chane s'il y est  */

		  if ( pointeur_char [ strlen (pointeur_char)-1 ] == 13 )
		    pointeur_char [ strlen (pointeur_char)-1 ] = 0;

		  /* rcupration de la date */

		  if ( pointeur_char[0] == 'D' )
		    operation -> date = g_strdup ( pointeur_char + 1 );


		  /* rcupration du pointage */

		  if ( pointeur_char[0] == 'C' )
		    {
		      if ( pointeur_char[1] == '*' )
			operation -> p_r = 1;
		      else
			operation -> p_r = 2;
		    }


		  /* rcupration de la note */

		  if ( pointeur_char[0] == 'M' )
		    {
		      operation -> notes = g_strstrip ( g_strdelimit ( pointeur_char + 1,
								       ";",
								       '/' ));
		      if ( !strlen ( operation -> notes ))
			operation -> notes = NULL;
		    }


		  /* rcupration du montant ( on doit virer la , que money met pour sparer les milliers ) */
		  /* on ne vire la , que s'il y a un . */

		  if ( pointeur_char[0] == 'T' )
		    {
		      gchar **tab;

		      tab = g_strsplit ( pointeur_char,
					 ".",
					 2 );

		      if( tab[1] )
			{
			  gchar **tab_char;

			  tab_char = g_strsplit ( pointeur_char,
						  ",",
						  FALSE );

			  pointeur_char = g_strjoinv ( NULL,
						       tab_char );
			  operation -> montant = g_strtod ( pointeur_char + 1,
							    NULL );
			  g_strfreev ( tab_char );
			}
		      else
			operation -> montant = g_strtod ( pointeur_char + 1,
							  NULL );

		      g_strfreev ( tab );
		    }

		  /* rcupration du chque */

		  if ( pointeur_char[0] == 'N' )
		    operation -> cheque = g_strtod ( pointeur_char + 1,
						     NULL );


		  /* rcupration du tiers */
	  
		  if ( pointeur_char[0] == 'P' )
		    operation -> tiers = g_strdup ( pointeur_char + 1 );


		  /* rcupration des catg */

		  if ( pointeur_char[0] == 'L' )
		    operation -> categ = g_strdup ( pointeur_char + 1 );


		  /* rcupration de la ventilation et de sa categ */

		  if ( pointeur_char[0] == 'S' )
		    {
		      /* on commence une ventilation, si une op tait en cours, on l'enregistre */

		      if ( retour != EOF && operation -> date )
			{
			  if ( !ventilation )
			    liste_ope_brut = g_slist_append ( liste_ope_brut,
							      operation );
			}
		      else
			{
			  /*c'est la fin du fichier ou l'op n'est pas valide, donc les ventils ne sont pas valides non plus */

			  free ( operation );

			  if ( ventilation )
			    free ( ventilation );

			  operation = NULL;
			  ventilation = NULL;
			}

		      /* si une ventilation tait en cours, on l'enregistre */

		      if ( ventilation )
			liste_ope_brut = g_slist_append ( liste_ope_brut,
							  ventilation );

		      ventilation = calloc ( 1,
					     sizeof ( struct struct_operation_qif ));

		      operation -> operation_ventilee = 1;

		      /* rcupration des donnes de l'opration en cours */

		      ventilation -> date = operation -> date;
		      ventilation -> tiers = operation -> tiers;
		      ventilation -> cheque = operation -> cheque;
		      ventilation -> p_r = operation -> p_r;
		      ventilation -> ope_de_ventilation = 1;

		      ventilation -> categ = g_strdup ( pointeur_char + 1 );
		    }


		  /* rcupration de la note de ventilation */

		  if ( pointeur_char[0] == 'E'
		       &&
		       ventilation )
		    {
		      ventilation -> notes = g_strstrip ( g_strdelimit ( pointeur_char + 1,
									 ";",
									 '/' ));

		      if ( !strlen ( ventilation -> notes ))
			ventilation -> notes = NULL;
		    }

		  /* rcupration du montant de la ventilation */
		  /* rcupration du montant ( on doit virer la , que money met pour sparer les milliers ) */
		  /* on ne vire la , que s'il y a un . */
		  /* comme money enregistre en ngatif ou en positif */
		  /* soit c'est du mme signe que l'op et on prend la valeur absolue */
		  /* soit c'est de signe contraire et on prend la vraie valeur */

		  if ( pointeur_char[0] == '$'
		       &&
		       ventilation )
		    {
		      gchar **tab;

		      tab = g_strsplit ( pointeur_char,
					 ".",
					 2 );

		      if( tab[1] )
			{
			  gchar **tab_char;

			  tab_char = g_strsplit ( pointeur_char,
						  ",",
						  FALSE );

			  pointeur_char = g_strjoinv ( NULL,
						       tab_char );
			  ventilation -> montant = g_strtod ( pointeur_char + 1,
							      NULL );

			  g_strfreev ( tab_char );
			}
		      else
			ventilation -> montant = g_strtod ( pointeur_char + 1,
							    NULL );

		      g_strfreev ( tab );

		    }

		}
	    }
	  while ( pointeur_char[0] != '^' && retour != EOF );


	  /* on n'enregistre l'opration que si elle est date */


	  if ( ventilation )
	    {
	      liste_ope_brut = g_slist_append ( liste_ope_brut,
						ventilation );
	      ventilation = NULL;
	    }
	  else
	    {
	      if ( retour != EOF && operation -> date )
		liste_ope_brut = g_slist_append ( liste_ope_brut,
						  operation );
	      else
		free ( operation );
	    }

	}
      while ( retour != EOF );

      fclose ( fichier_qif );


      /* pour l'instant, on met la liste cre dans la liste des ops du compte */

      compte -> gsliste_operations = liste_ope_brut;

      selection = selection -> next;
    }

  gtk_widget_hide ( fenetre );


  traitement_donnees_brutes();
}
/* *******************************************************************************/









/* *******************************************************************************/
void traitement_donnees_brutes ( void )
{
  gint retour;
  GtkWidget *dialog;
  GtkWidget *label;
  GSList *liste_tmp;
  GtkWidget *frame;
  GtkWidget *vbox;
  GSList *liste_comptes_tmp;
  gint nb_comptes_ajoutes;
  gint nouveau_fichier;
  GtkWidget *scrolled_window;

  if ( !liste_comptes_qif )
    return;


  /* on permet ici de rcuprer d'autres comptes */


  dialog = gnome_dialog_new ( "Liste des comptes imports",
			      GNOME_STOCK_BUTTON_YES,
			      GNOME_STOCK_BUTTON_NO,
			      GNOME_STOCK_BUTTON_CANCEL,
			      NULL );
  gtk_window_set_transient_for ( GTK_WINDOW ( dialog ),
				 GTK_WINDOW ( window ));
  gnome_dialog_set_default ( GNOME_DIALOG ( dialog ),
			     0 );

  if ( g_slist_length ( liste_comptes_qif ) == 1 )
    label = gtk_label_new ( "Compte  importer :\n" );
  else
    label = gtk_label_new ( "Comptes  importer :\n" );

  gtk_box_pack_start ( GTK_BOX ( GNOME_DIALOG ( dialog ) -> vbox ),
		       label,
		       FALSE,
		       FALSE,
		       0 );
  gtk_widget_show ( label );


  frame = gtk_frame_new ( NULL );
  gtk_box_pack_start ( GTK_BOX ( GNOME_DIALOG ( dialog ) -> vbox ),
		       frame,
		       FALSE,
		       FALSE,
		       0 );
  gtk_widget_show ( frame );

  scrolled_window = gtk_scrolled_window_new ( NULL,
					      NULL );
  gtk_scrolled_window_set_policy ( GTK_SCROLLED_WINDOW ( scrolled_window ),
				   GTK_POLICY_AUTOMATIC,
				   GTK_POLICY_AUTOMATIC );
  gtk_container_add ( GTK_CONTAINER ( frame ),
		      scrolled_window );
  gtk_widget_show ( scrolled_window );


  vbox = gtk_vbox_new ( FALSE,
			10 );
  gtk_container_set_border_width ( GTK_CONTAINER ( vbox ),
				   10 );
  gtk_scrolled_window_add_with_viewport ( GTK_SCROLLED_WINDOW ( scrolled_window ),
					  vbox );
  gtk_widget_set_usize ( scrolled_window,
			 200,
			 200 );
  gtk_widget_show ( vbox );



  liste_tmp = liste_comptes_qif;

  while ( liste_tmp )
    {
      label = gtk_label_new ( (( struct donnees_compte * )( liste_tmp -> data )) -> nom_de_compte );
      gtk_misc_set_alignment ( GTK_MISC ( label ),
			       0,
			       0.5 );
      gtk_box_pack_start ( GTK_BOX ( vbox ),
			   label,
			   FALSE,
			   FALSE,
			   0 );
      gtk_widget_show ( label );

      liste_tmp = liste_tmp -> next;
    }

  label = gtk_label_new ( "\nY a t'il d'autres compte  importer ?" );
  gtk_box_pack_start ( GTK_BOX ( GNOME_DIALOG ( dialog ) -> vbox ),
		       label,
		       FALSE,
		       FALSE,
		       0 );
  gtk_widget_show ( label );


  retour = gnome_dialog_run_and_close ( GNOME_DIALOG ( dialog ));


  /*   si on veut importer un autre compte, on renvoie sur selection_fichier_qif */

  if ( !retour )
    {
      selection_fichier_qif();
      return;
    }

  /*   si on annule : on s'en va */

  if ( retour == 2 )
    return;


  /* on ralise maintenant les transformations pour importer les fichiers */

/* fait le ncessaire si aucun compte n'est ouvert */

  if ( !nb_comptes )
    {
      init_variables ( FALSE );
      init_variables ( TRUE );
      creation_liste_categories ();

      nom_fichier_comptes = NULL;
      nouveau_fichier = 1;
      affiche_titre_fenetre();
    }
  else
      nouveau_fichier = 0;


  /* on commence par enregistrer les comptes */

  nb_comptes_ajoutes = 0;
  liste_comptes_tmp = liste_comptes_qif;

  while ( liste_comptes_tmp )
    {
      struct donnees_compte *compte;
      GtkWidget *bouton;
      gint compte_visible;

      compte = liste_comptes_tmp -> data;

      /* enregistre le compte */

      compte_visible = p_tab_nom_de_compte_courant - p_tab_nom_de_compte;

      p_tab_nom_de_compte = realloc ( p_tab_nom_de_compte, ( nb_comptes + 1 )* sizeof ( gpointer ) );
      p_tab_nom_de_compte_variable = p_tab_nom_de_compte + nb_comptes;
      nb_comptes++;
      *p_tab_nom_de_compte_variable = (gpointer) compte;

      p_tab_nom_de_compte_courant = p_tab_nom_de_compte + compte_visible; 


      /* choix de la devise du compte */

      compte -> devise = selection_devise ( compte -> nom_de_compte );

      /* met le no de compte */

      compte -> no_compte = nb_comptes - 1;

      ordre_comptes = g_slist_append ( ordre_comptes,
				       GINT_TO_POINTER ( nb_comptes - 1 ));

      /* on cre les types d'op par dfaut */

      creation_types_par_defaut ( nb_comptes - 1,
				  0);
      if ( !nouveau_fichier )
	{
	  /* cre le nouveau bouton du compte et l'ajoute  la liste des comptes */

	  bouton = comptes_appel(nb_comptes - 1 );
	  gtk_box_pack_start (GTK_BOX (vbox_liste_comptes),
			      bouton,
			      FALSE,
			      FALSE,
			      0);
	  gtk_widget_show (bouton);
	}

      nb_comptes_ajoutes++;

      liste_comptes_tmp = liste_comptes_tmp -> next;
    }

  p_tab_nom_de_compte_courant = p_tab_nom_de_compte + compte_courant;


  /* on fait maintenant le tour des ops et cette fois on les convertit */


  liste_comptes_tmp = liste_comptes_qif;

  while ( liste_comptes_tmp )
    {
      struct donnees_compte *compte;
      gdouble solde_courant;
      struct structure_operation *operation;
      gint format_date;
      GSList *save_gsliste;
      gint derniere_operation;
      GSList *liste_ope_brut;

      derniere_operation = 0;
      compte = liste_comptes_tmp -> data;

      /*       au dbut, on considre que la date est sous forme jjmmaa, si pb, on passe  mmjjaa */

      format_date = 0;
      liste_ope_brut = compte -> gsliste_operations;

      changement_format_date :

      compte -> nb_operations = 0;
      liste_tmp = liste_ope_brut;
      save_gsliste = liste_tmp;

      compte -> gsliste_operations = NULL;
      solde_courant = compte -> solde_initial;

      while ( liste_tmp )
	{
	  struct struct_operation_qif *operation_qif;
	  gchar **tab_str;
	  GSList *pointeur_tmp;

	  operation_qif = liste_tmp -> data;

	  /* 	  vrification qu'il y a une date, sinon ce n'est pas une op, on prend pas */

	  if ( operation_qif -> date )
	    {
	      operation = calloc ( 1,
				   sizeof ( struct structure_operation ));


	      /* rcupration du no de l'op */

	      operation -> no_operation = ++no_derniere_operation;
	      
	      /* rcupration de la date qui est du format jj/mm/aaaa ou jj/mm/aa ou jj/mm'aa  partir de 2000 */
	      /* 	      si format_date = 0, c'est sous la forme jjmm sinon mmjj */


	      tab_str = g_strsplit ( operation_qif -> date,
				     "/",
				     3 );

	      if ( tab_str [2] && tab_str [1] )
		{
		  /* 		  le format est xx/xx/xx, pas d'apostrophe */

		  if ( format_date )
		    {
		      operation -> mois = g_strtod ( tab_str[0],
						     NULL );
		      operation -> jour = g_strtod ( tab_str[1],
						     NULL );
		    }
		  else
		    {
		      operation -> jour = g_strtod ( tab_str[0],
						     NULL );
		      operation -> mois = g_strtod ( tab_str[1],
						     NULL );
		    }

		  if ( strlen ( tab_str[2] ) == 4 )
		    operation -> annee = g_strtod ( tab_str[2],
						    NULL );
		  else
		    {
		      operation -> annee = g_strtod ( tab_str[2],
						      NULL );
		      if ( operation -> annee < 80 )
			operation -> annee = operation -> annee + 2000;
		      else
			operation -> annee = operation -> annee + 1900;
		    }
		}
	      else
		{
		  if ( tab_str[1] )
		    {
		      /* le format est xx/xx'xx */

		      gchar **tab_str2;

		      tab_str2 = g_strsplit ( tab_str[1],
					      "'",
					      2 );

		      if ( format_date )
			{
			  operation -> mois = g_strtod ( tab_str[0],
							 NULL );
			  operation -> jour = g_strtod ( tab_str2[0],
							 NULL );
			}
		      else
			{
			  operation -> jour = g_strtod ( tab_str[0],
							 NULL );
			  operation -> mois = g_strtod ( tab_str2[0],
							 NULL );
			}

		      /* si on avait 'xx, en fait a peut tre 'xx ou 'xxxx ... */

		      if ( strlen ( tab_str2[1] ) == 2 )
			operation -> annee = g_strtod ( tab_str2[1],
							NULL ) + 2000;
		      else
			operation -> annee = g_strtod ( tab_str2[1],
							NULL );
		      g_strfreev ( tab_str2 );

		    }
		  else
		    {
		      /* le format est aaaa-mm-jj */

		      tab_str = g_strsplit ( operation_qif -> date,
					     "-",
					     3 );

		      operation -> mois = g_strtod ( tab_str[1],
						     NULL );
		      operation -> jour = g_strtod ( tab_str[2],
						     NULL );
		      if ( strlen ( tab_str[0] ) == 4 )
			operation -> annee = g_strtod ( tab_str[0],
							NULL );
		      else
			{
			  operation -> annee = g_strtod ( tab_str[0],
							NULL );
			if ( operation -> annee < 80 )
			  operation -> annee = operation -> annee + 2000;
			else
			  operation -> annee = operation -> annee + 1900;
			}

		    }
		}

	      g_strfreev ( tab_str );

	      if ( g_date_valid_dmy ( operation -> jour,
				      operation -> mois,
				      operation -> annee ))
		operation -> date = g_date_new_dmy ( operation -> jour,
						     operation -> mois,
						     operation -> annee );
	      else
		{
		  if ( format_date )
		    {
		      dialogue ( "Problme dans la rcupration des dates du fichier QIF. Opration annule" );
		      return;
		    }

		  format_date = 1;

		  goto changement_format_date;
		}

	      /* rcupration du no de compte ( stock pour l'instant dans no_derniere_operation ) */

	      operation -> no_compte = compte->no_compte;


	      /* rcupration du montant */

	      operation -> montant = operation_qif -> montant;
	      solde_courant = solde_courant + operation_qif -> montant;

	      operation -> devise = compte -> devise;

	      /* rcupration du tiers */

	      if ( operation_qif -> tiers )
		{
		  pointeur_tmp = g_slist_find_custom ( liste_struct_tiers,
						       g_strstrip ( operation_qif -> tiers ),
						       (GCompareFunc) recherche_tiers_par_nom );

		  /* si le tiers n'existait pas, on le cre */

		  if ( pointeur_tmp )
		    operation -> tiers = ((struct struct_tiers *)(pointeur_tmp -> data)) -> no_tiers;
		  else
		    operation -> tiers = (( struct struct_tiers * )( ajoute_nouveau_tiers ( operation_qif -> tiers ))) -> no_tiers;

		}


	      /* vrification si c'est ventil, sinon rcupration des catgories */


	      if ( operation_qif -> operation_ventilee )
		{
		  /* l'opration est ventile */

		  operation -> operation_ventilee = 1;
		}
	      else
		{
		  /* vrification que ce n'est pas un virement */

		  if ( operation_qif -> categ && strlen ( g_strstrip (operation_qif -> categ)) )
		    {
		      if ( operation_qif -> categ[0] == '[' )
			{
			  /* recherche du compte en relation ( on cherchera l'op ensuite, une fois */
			  /* que toutes les ops auront t importes */

			  gint i;

			  p_tab_nom_de_compte_variable = p_tab_nom_de_compte;

			  for ( i = 0 ; i < nb_comptes ; i++ )
			    {
			      if ( !g_strcasecmp ( g_strconcat ( "[",
								 NOM_DU_COMPTE,
								 "]",
								 NULL ),
						   operation_qif -> categ ))
				{
				  /* on a trouv le compte, met la relation de l'op  -1 pour dire qu'il faut la chercher */
				  operation -> relation_no_compte = i;
				  operation -> relation_no_operation = -1;
				}
			      p_tab_nom_de_compte_variable++;
			    }
			}
		      else
			{
			  struct struct_categ *categ;
			  struct struct_sous_categ *sous_categ ;


			  tab_str = g_strsplit ( operation_qif -> categ,
						 ":",
						 2 );


			  /* rcupration ou cration de la catgorie */

			  if ( !g_slist_find_custom ( liste_struct_categories,
						      g_strstrip ( tab_str[0] ),
						      (GCompareFunc) recherche_categorie_par_nom ))
			    {
			      categ = calloc ( 1,
					       sizeof ( struct struct_categ ));

			      categ -> no_categ = ++no_derniere_categorie;
			      categ -> nom_categ = g_strdup ( g_strstrip ( tab_str[0] ) );

			      if ( operation_qif -> montant < 0 )
				categ -> type_categ = 1;
			      else
				categ -> type_categ = 0;

			      nb_enregistrements_categories++;

			      liste_struct_categories = g_slist_append ( liste_struct_categories,
									 categ );
			    }
			  else
			    categ = g_slist_find_custom ( liste_struct_categories,
							  g_strstrip ( tab_str[0] ),
							  (GCompareFunc) recherche_categorie_par_nom ) -> data;


			  operation -> categorie = categ -> no_categ;


			  /* rcupration ou cration de la sous-catgorie */

			  if ( tab_str[1] )
			    {
			      if ( !g_slist_find_custom ( categ -> liste_sous_categ,
							  g_strstrip ( tab_str[1] ),
							  (GCompareFunc) recherche_sous_categorie_par_nom ))
				{
				  sous_categ = calloc ( 1,
							sizeof ( struct struct_sous_categ ));

				  sous_categ -> no_sous_categ = ++( categ -> no_derniere_sous_categ );
				  sous_categ -> nom_sous_categ = g_strdup ( g_strstrip ( tab_str[1] ));

				  categ -> liste_sous_categ = g_slist_append ( categ -> liste_sous_categ,
									       sous_categ );
				}
			      else
				sous_categ = g_slist_find_custom ( categ -> liste_sous_categ,
								   g_strstrip ( tab_str[1] ),
								   (GCompareFunc) recherche_sous_categorie_par_nom ) -> data;

			      operation -> sous_categorie = sous_categ -> no_sous_categ;

			    }

			  g_strfreev ( tab_str );

			}
		    }
		}

	      /* rcupration des notes */

	      operation -> notes = operation_qif -> notes;


	      p_tab_nom_de_compte_variable = p_tab_nom_de_compte_courant;

	      /* rcupration du chque et mise en forme du type d'opration */

	      if ( operation_qif -> cheque )
		{
		  /* c'est un chque, on va rechercher un type  incrmentation automatique et mettre l'op sous ce type */
		  /* si un tel type n'existe pas, on met quand mme le no dans contenu_type et on met le type par dfaut */

		  struct struct_type_ope *type_choisi;
		  GSList *liste_tmp;

		  if ( operation -> montant < 0 )
		    operation -> type_ope = TYPE_DEFAUT_DEBIT;
		  else
		    operation -> type_ope = TYPE_DEFAUT_CREDIT;

		  operation -> contenu_type = itoa ( operation_qif -> cheque );

		  liste_tmp = TYPES_OPES;
		  type_choisi = NULL;

		  while ( liste_tmp )
		    {
		      struct struct_type_ope *type;

		      type = liste_tmp -> data;

		      /* si l'op on trouve un type  incrmentation automatique et que le signe du type est bon, on l'enregistre */
		      /*   et on arrte la recherche, sinon, on l'enregistre mais on continue la recherche dans l'espoir de trouver */
		      /* mieux */

		      if ( type -> numerotation_auto )
			{
			  if ( !type -> signe_type
			       ||
			       ( type -> signe_type == 1 && operation -> montant < 0 )
			       ||
			       ( type -> signe_type == 2 && operation -> montant > 0 ))
			    {
			      operation -> type_ope = type -> no_type;
			      type_choisi = type;
			      liste_tmp = NULL;
			    }
			  else
			    {
			      operation -> type_ope = type -> no_type;
			      type_choisi = type;
			      liste_tmp = liste_tmp -> next;
			    }
			}
		      else
			liste_tmp = liste_tmp -> next;
		    }

		  /* type_choisi contient l'adr du type qui a t utilis, on peut y mettre le dernier no de chque */

		  if ( type_choisi )
		    type_choisi -> no_en_cours = MAX ( operation_qif -> cheque,
						       type_choisi -> no_en_cours );
		}
	      else
		{
		  /* comme ce n'est pas un chque, on met sur le type par dfaut */

		  if ( operation -> montant < 0 )
		    operation -> type_ope = TYPE_DEFAUT_DEBIT;
		  else
		    operation -> type_ope = TYPE_DEFAUT_CREDIT;

		}


	      /* rcupration du point */

	      operation -> pointe = operation_qif -> p_r;


	      /* si c'est une ope de ventilation, lui ajoute le no de l'opration prcdente */

	      if ( operation_qif -> ope_de_ventilation )
		operation -> no_operation_ventilee_associee = derniere_operation;
	      else
		derniere_operation = operation -> no_operation;


	      /* ajoute l'opration dans la liste des ops du compte */

	      compte -> gsliste_operations = g_slist_append ( compte -> gsliste_operations,
							      operation );
	      compte -> nb_operations++;
	    }

	  liste_tmp = liste_tmp -> next;
	}


      compte -> solde_courant = solde_courant;
      compte -> date_releve = NULL;
      compte -> operation_selectionnee = GINT_TO_POINTER ( -1 );

      liste_comptes_tmp = liste_comptes_tmp -> next;
    }



  /* on fait maintenant le lien entre les diffrents virements : */
  /* on fait le tour de toutes les ops des comptes ajouts, */
  /* si une op  un relation_no_operation  -1 , */
  /* on recherche dans le compte associ une op avec aussi une relation_no_operation  -1  */
  /* le mme jour avec le mme tiers */


  liste_comptes_tmp = liste_comptes_qif;

  while ( liste_comptes_tmp )
    {
      struct donnees_compte *compte;
      struct structure_operation *operation;


      compte = liste_comptes_tmp -> data;

      liste_tmp = compte -> gsliste_operations;

      while ( liste_tmp )
	{

	  operation = liste_tmp -> data;


	  if ( operation -> relation_no_operation == -1 )
	    {
	      GSList *pointeur_tmp;

	      p_tab_nom_de_compte_variable = p_tab_nom_de_compte + operation -> relation_no_compte;

	      pointeur_tmp = LISTE_OPERATIONS;

	      while ( pointeur_tmp )
		{
		  struct structure_operation *operation_2;

		  operation_2 = pointeur_tmp -> data;

		  if ( operation_2 -> relation_no_operation == -1 )
		    {
		      if ( !g_date_compare ( operation -> date, operation_2 -> date )
			   &&
			   ( operation -> tiers == operation_2 -> tiers )
			   &&
			   ( fabs ( operation -> montant ) == fabs ( operation_2 -> montant ) ))
			{
			  operation -> relation_no_operation = operation_2 -> no_operation;
			  operation_2 -> relation_no_operation = operation -> no_operation;
			}
		    }

		  pointeur_tmp = pointeur_tmp -> next;
		}

	    }
	  liste_tmp = liste_tmp -> next;
	}

      liste_comptes_tmp = liste_comptes_tmp -> next;
    }



  /* cration des listes d'op */

  mise_en_route_attente ( "Le traitement des informations peut prendre un certain temps ..." );

  if ( nouveau_fichier )
    {
      creation_fenetre_principale();

      creation_listes_operations ();
      changement_compte ( GINT_TO_POINTER ( compte_courant ) );
      gtk_notebook_set_page ( GTK_NOTEBOOK ( notebook_general ),
			      0 );
    }
  else
    while ( nb_comptes_ajoutes )
      {
	/* trie la liste */

	p_tab_nom_de_compte_variable = p_tab_nom_de_compte + nb_comptes - nb_comptes_ajoutes;

	LISTE_OPERATIONS = g_slist_sort ( LISTE_OPERATIONS,
					  ( GCompareFunc ) comparaison_date_list_ope );

	ajoute_nouvelle_liste_operation( nb_comptes - nb_comptes_ajoutes );
	nb_comptes_ajoutes--;

	p_tab_nom_de_compte_variable = p_tab_nom_de_compte + compte_courant;
	MISE_A_JOUR = 1;
      }


  /* on recre les combofix des tiers et des catgories */

  mise_a_jour_tiers ();
  mise_a_jour_categ();

/* on met  jour l'option menu du formulaire des chances */

  gtk_option_menu_set_menu ( GTK_OPTION_MENU ( widget_formulaire_echeancier[5] ),
			     creation_option_menu_comptes () );

  /* mise  jour de l'accueil */

  update_liste_comptes_accueil ();
  mise_a_jour_soldes_minimaux ();

  affiche_titre_fenetre ();

  annulation_attente();

  gnome_app_set_contents ( GNOME_APP ( window ), 
			   notebook_general );
  modification_fichier ( TRUE );
}
/* *******************************************************************************/




/* *******************************************************************************/
/* Affiche la fentre de slection de fichier pour exporter en qif */
/* *******************************************************************************/

void exporter_fichier_qif ( void )
{
  GtkWidget *dialog;
  GtkWidget *label;
  GtkWidget *frame;
  GtkWidget *table;
  GtkWidget *entree;
  GtkWidget *check_button;
  gint i;
  gint resultat;
  GSList *liste_tmp;
  gchar *nom_fichier_qif;
  FILE *fichier_qif;
  gchar *montant_tmp;
  

  if ( !nom_fichier_comptes )
    {
      dialogue ( "Vous devez nommer ( enregistrer ) votre fichier pour pouvoir l'exporter. " );
      return;
    }


  dialogue ( "Attention, le format QIF ne grant pas les devises,\ntoutes les oprations seront converties dans la devise de leur compte respectif." );

  dialog = gnome_dialog_new ( "Exporter des fichiers QIF",
			      GNOME_STOCK_BUTTON_OK,
			      GNOME_STOCK_BUTTON_CANCEL,
			      NULL );
  gtk_window_set_transient_for ( GTK_WINDOW ( dialog ),
				 GTK_WINDOW ( window ));
  gtk_signal_connect ( GTK_OBJECT ( dialog ),
		       "destroy",
		       GTK_SIGNAL_FUNC ( gtk_signal_emit_stop_by_name ),
		        "destroy" );

  label = gtk_label_new ( "Slectionner les comptes  exporter :" );
  gtk_box_pack_start ( GTK_BOX ( GNOME_DIALOG ( dialog ) -> vbox ),
		       label,
		       FALSE,
		       FALSE,
		       5 );
  gtk_widget_show ( label );

  frame = gtk_frame_new ( NULL );
  gtk_box_pack_start ( GTK_BOX ( GNOME_DIALOG ( dialog ) -> vbox ),
		       frame,
		       FALSE,
		       FALSE,
		       5 );
  gtk_widget_show ( frame );


  table = gtk_table_new ( 3,
			  nb_comptes,
			  FALSE );
  gtk_container_set_border_width ( GTK_CONTAINER ( table ),
				   10 );
  gtk_table_set_col_spacings ( GTK_TABLE ( table ),
			       10 );
  gtk_container_add ( GTK_CONTAINER ( frame ),
		      table );
  gtk_widget_show ( table );



  /* on met chaque compte dans la table */

  p_tab_nom_de_compte_variable = p_tab_nom_de_compte;

  for ( i = 0 ; i < nb_comptes ; i++ )
    {

      check_button = gtk_check_button_new ();
      gtk_table_attach ( GTK_TABLE ( table ),
			 check_button,
			 0, 1,
			 i, i+1,
			 GTK_SHRINK | GTK_FILL,
			 GTK_SHRINK | GTK_FILL,
			 0, 0 );
      gtk_widget_show ( check_button );

      label = gtk_label_new ( NOM_DU_COMPTE );
      gtk_misc_set_alignment ( GTK_MISC ( label ),
			       0,
			       0.5 );
      gtk_table_attach ( GTK_TABLE ( table ),
			 label,
			 1, 2,
			 i, i+1,
			 GTK_SHRINK | GTK_FILL,
			 GTK_SHRINK | GTK_FILL,
			 0, 0 );
      gtk_widget_show ( label );

      entree = gnome_file_entry_new ("qif", "Exportation d'un fichier QIF");
      gtk_widget_set_usize ( GTK_WIDGET ( gnome_file_entry_gtk_entry ( GNOME_FILE_ENTRY ( entree ) )),
			     300,
			     FALSE );
      gnome_file_entry_set_default_path ( GNOME_FILE_ENTRY ( entree ),
					  dernier_chemin_de_travail );
      gtk_entry_set_text ( GTK_ENTRY (gnome_file_entry_gtk_entry ( GNOME_FILE_ENTRY ( entree ) ) ),
			   g_strconcat ( nom_fichier_comptes,
					 "-",
					 g_strdelimit ( g_strdup ( NOM_DU_COMPTE) , " ", '_' ),
					 ".qif",
					 NULL ));
      gtk_widget_set_sensitive ( entree,
				 FALSE );
      gtk_object_set_data ( GTK_OBJECT ( gnome_file_entry_gtk_entry ( GNOME_FILE_ENTRY ( entree ) ) ),
			    "no_compte",
			    GINT_TO_POINTER ( i ));
      gtk_table_attach ( GTK_TABLE ( table ),
			 entree,
			 2, 3,
			 i, i+1,
			 GTK_SHRINK | GTK_FILL,
			 GTK_SHRINK | GTK_FILL,
			 0, 0 );
      gtk_widget_show ( entree );


      /*       si on clique sur le check bouton, a rend ditable l'entre */

      gtk_signal_connect ( GTK_OBJECT ( check_button ),
			   "toggled",
			   GTK_SIGNAL_FUNC ( click_compte_export_qif ),
			   entree );

      p_tab_nom_de_compte_variable++;
    }

  liste_entrees_exportation = NULL;

 choix_liste_fichier:
  resultat = gnome_dialog_run ( GNOME_DIALOG ( dialog ));

  if ( resultat || !liste_entrees_exportation )
    {
      if ( liste_entrees_exportation )
	g_slist_free ( liste_entrees_exportation );

      gnome_dialog_close ( GNOME_DIALOG ( dialog ));
      return;
    }

  /* vrification que tous les fichiers sont enregistrables */

  liste_tmp = liste_entrees_exportation;

  while ( liste_tmp )
    {
      struct stat test_fichier;


      nom_fichier_qif = gtk_entry_get_text ( GTK_ENTRY ( liste_tmp -> data ));


      if ( stat ( nom_fichier_qif,
		  &test_fichier ) != -1 )
	{
	  if ( S_ISREG ( test_fichier.st_mode ) )
	    {
	      GtkWidget *etes_vous_sur;

	      etes_vous_sur = gnome_dialog_new ( "Enregistrer le fichier",
						 GNOME_STOCK_BUTTON_YES,
						 GNOME_STOCK_BUTTON_NO,
						 NULL );
	      label = gtk_label_new ( "Le fichier existe. Voulez-vous l'craser ?" );
	      gtk_box_pack_start ( GTK_BOX ( GNOME_DIALOG ( etes_vous_sur ) -> vbox ),
				   label,
				   TRUE,
				   TRUE,
				   5 );
	      gtk_widget_show ( label );

	      gnome_dialog_set_default ( GNOME_DIALOG ( etes_vous_sur ),
					 1 );
	      gtk_window_set_transient_for ( GTK_WINDOW ( etes_vous_sur ),
					     GTK_WINDOW ( dialog ));

	      if ( gnome_dialog_run_and_close ( GNOME_DIALOG ( etes_vous_sur ) ) )
		goto choix_liste_fichier;
	    }
	  else
	    {
	      dialogue ( g_strconcat ( "Nom de fichier \"",
				       nom_fichier_qif,
				       "\" invalide !",
				       NULL ));
	      goto choix_liste_fichier;
	    }
	}


      liste_tmp = liste_tmp -> next;
    }



  /* on est sr de l'enregistrement, c'est parti ... */


  liste_tmp = liste_entrees_exportation;

  while ( liste_tmp )
    {

      /*       ouverture du fichier, si pb, on marque l'erreur et passe au fichier suivant */

      nom_fichier_qif = gtk_entry_get_text ( GTK_ENTRY ( liste_tmp -> data ));

      if ( !( fichier_qif = fopen ( nom_fichier_qif,
				    "w" ) ))
	dialogue ( g_strconcat ( "L'erreur suivante s'est produite pour le fichier\n",
				 nom_fichier_qif,
				 " :\n",
				 strerror ( errno ),
				 NULL ));
      else
	{
	  GSList *pointeur_tmp;
	  struct structure_operation *operation;

	  p_tab_nom_de_compte_variable = 
	    p_tab_nom_de_compte
	    +
	    GPOINTER_TO_INT ( gtk_object_get_data ( GTK_OBJECT ( liste_tmp -> data ),
						    "no_compte" ));

	  /* met le type de compte */

	  if ( TYPE_DE_COMPTE == 1 )
	    fprintf ( fichier_qif,
		      "!Type:Cash\n" );
	  else
	    if ( TYPE_DE_COMPTE == 2 )
	      fprintf ( fichier_qif,
			"!Type:Oth L\n" );
	    else
	      fprintf ( fichier_qif,
			"!Type:Bank\n" );


	  if ( LISTE_OPERATIONS )
	    {
	      struct struct_devise *devise_compte;

	      /* rcupre la devise du compte */

	      devise_compte = g_slist_find_custom ( liste_struct_devises,
						    GINT_TO_POINTER ( DEVISE ),
						    ( GCompareFunc ) recherche_devise_par_no ) -> data;


	      /* met la date de la 1re opration comme dte d'ouverture de compte */

	      operation = LISTE_OPERATIONS -> data;

	      fprintf ( fichier_qif,
			"D%d/%d/%d\n",
			operation -> jour,
			operation -> mois,
			operation -> annee );



	      /* met le solde initial */

	      montant_tmp = g_strdup_printf ( "%4.2f",
					      SOLDE_INIT );
	      montant_tmp = g_strdelimit ( montant_tmp,
					   ",",
					   '.' );

	      fprintf ( fichier_qif,
			"T%s\n",
			montant_tmp );


	      fprintf ( fichier_qif,
			"CX\nPOpening Balance\n" );

	      /* met le nom du compte */

	      fprintf ( fichier_qif,
			"L%s\n^\n",
			g_strconcat ( "[",
				      NOM_DU_COMPTE,
				      "]",
				      NULL ) );

	      /* on met toutes les oprations */

	      pointeur_tmp = LISTE_OPERATIONS;

	      while ( pointeur_tmp )
		{
		  GSList *pointeur;
		  gdouble montant;
		  struct struct_type_ope *type;

		  operation = pointeur_tmp -> data;


		  /* si c'est une op de ventilation, on la saute pas elle sera recherche quand */
		  /* son op ventile sera exporte */

		  if ( !operation -> no_operation_ventilee_associee )
		    {
		      /* met la date */

		      fprintf ( fichier_qif,
				"D%d/%d/%d\n",
				operation -> jour,
				operation -> mois,
				operation -> annee );


		      /* met le pointage */

		      if ( operation -> pointe == 1 )
			fprintf ( fichier_qif,
				  "C*\n" );
		      else
			if ( operation -> pointe == 2 )
			  fprintf ( fichier_qif,
				    "CX\n" );


		      /* met les notes */

		      if ( operation -> notes )
			fprintf ( fichier_qif,
				  "M%s\n",
				  operation -> notes );


		      /* met le montant, transforme la devise si necessaire */

		      if ( operation -> devise == DEVISE )
			montant = operation -> montant;
		      else
			{
			  /* ce n'est pas la devise du compte, si le compte passe  l'euro et que la devise est l'euro, */
			  /* utilise la conversion du compte,  sinon utilise la conversion stocke dans l'op */

			  struct struct_devise *devise_operation;

			  devise_operation = g_slist_find_custom ( liste_struct_devises,
								   GINT_TO_POINTER ( operation -> devise ),
								   ( GCompareFunc ) recherche_devise_par_no ) -> data;

			  if ( devise_compte -> passage_euro
			       &&
			       !strcmp ( devise_operation -> nom_devise, "Euro" ) )
			    montant = operation -> montant * devise_compte -> change;
			  else
			    if ( devise_operation -> passage_euro
				 &&
				 !strcmp ( devise_compte -> nom_devise, "Euro" ))
			      montant = operation -> montant / devise_operation -> change;
			    else
			      if ( operation -> une_devise_compte_egale_x_devise_ope )
				montant = operation -> montant / operation -> taux_change - operation -> frais_change;
			      else
				montant = operation -> montant * operation -> taux_change - operation -> frais_change;
			  montant = ( rint (montant * 100 )) / 100;
			}

		      montant_tmp = g_strdup_printf ( "%4.2f",
						      montant );
		      montant_tmp = g_strdelimit ( montant_tmp,
						   ",",
						   '.' );

		      fprintf ( fichier_qif,
				"T%s\n",
				montant_tmp );


		      /* met le chque si c'est un type  numrotation automatique */

		      type = g_slist_find_custom ( TYPES_OPES,
						   GINT_TO_POINTER ( operation -> type_ope ),
						   (GCompareFunc) recherche_type_ope_par_no ) -> data;

		      if ( type -> numerotation_auto )
			fprintf ( fichier_qif,
				  "N%s\n",
				  operation -> contenu_type );


		      /* met le tiers */

		      pointeur = g_slist_find_custom ( liste_struct_tiers,
						       GINT_TO_POINTER ( operation -> tiers ),
						       (GCompareFunc) recherche_tiers_par_no );

		      if ( pointeur )
			fprintf ( fichier_qif,
				  "P%s\n",
				  ((struct struct_tiers *)(pointeur -> data )) -> nom_tiers );



		      /*  on met soit un virement, soit une ventilation, soit les catgories */

		      /* si c'est une ventilation, on recherche toutes les ops de cette ventilation */
		      /* et les met  la suite */
		      /* la catgorie de l'op sera celle de la premire op de ventilation */

		      if ( operation -> operation_ventilee )
			{
			  GSList *liste_ventil;
			  gint categ_ope_mise;

			  categ_ope_mise = 0;
			  liste_ventil = LISTE_OPERATIONS;

			  while ( liste_ventil )
			    {
			      struct structure_operation *ope_test;

			      ope_test = liste_ventil -> data;

			      if ( ope_test -> no_operation_ventilee_associee == operation -> no_operation
				   &&
				   ( ope_test -> categorie
				     ||
				     ope_test -> relation_no_operation ))
				{
				  /* on commence par mettre la catg et sous categ de l'op et de l'op de ventilation */

				  if ( ope_test -> relation_no_operation )
				    {
				      /* c'est un virement */
				      
				      gpointer **save_ptab;

				      save_ptab = p_tab_nom_de_compte_variable;

				      p_tab_nom_de_compte_variable = p_tab_nom_de_compte + ope_test -> relation_no_compte;

				      if ( !categ_ope_mise )
					{
					  fprintf ( fichier_qif,
						    "L%s\n",
						    g_strconcat ( "[",
								  NOM_DU_COMPTE,
								  "]",
								  NULL ));
					  categ_ope_mise = 1;
					}

				      fprintf ( fichier_qif,
						"S%s\n",
						g_strconcat ( "[",
							      NOM_DU_COMPTE,
							      "]",
							      NULL ));

				      p_tab_nom_de_compte_variable = save_ptab;
				    }
				  else
				    {
				      /* c'est du type categ : sous categ */

				      pointeur = g_slist_find_custom ( liste_struct_categories,
								       GINT_TO_POINTER ( ope_test -> categorie ),
								       (GCompareFunc) recherche_categorie_par_no );

				      if ( pointeur )
					{
					  GSList *pointeur_2;
					  struct struct_categ *categorie;

					  categorie = pointeur -> data;

					  pointeur_2 = g_slist_find_custom ( categorie -> liste_sous_categ,
									     GINT_TO_POINTER ( ope_test -> sous_categorie ),
									     (GCompareFunc) recherche_sous_categorie_par_no );
					  if ( pointeur_2 )
					    {
					      if ( !categ_ope_mise )
						{
						  fprintf ( fichier_qif,
							    "L%s\n",
							    g_strconcat ( categorie -> nom_categ,
									  ":",
									  ((struct struct_sous_categ *)(pointeur_2->data)) -> nom_sous_categ,
									  NULL ));
						  categ_ope_mise = 1;
						}

					      fprintf ( fichier_qif,
							"S%s\n",
							g_strconcat ( categorie -> nom_categ,
								      ":",
								      ((struct struct_sous_categ *)(pointeur_2->data)) -> nom_sous_categ,
								      NULL ));
					    }
					  else
					    {
					      if ( !categ_ope_mise )
						{
						  fprintf ( fichier_qif,
							    "L%s\n",
							    categorie -> nom_categ );
						  categ_ope_mise = 1;
						}

					      fprintf ( fichier_qif,
							"S%s\n",
							categorie -> nom_categ );
					    }
					}
				    }


				/* met les notes de la ventilation */

				  if ( ope_test -> notes )
				    fprintf ( fichier_qif,
					      "E%s\n",
					      ope_test -> notes );

				/* met le montant de la ventilation */


				  montant_tmp = g_strdup_printf ( "%4.2f",
								  ope_test -> montant );
				  montant_tmp = g_strdelimit ( montant_tmp,
							       ",",
							       '.' );

				  fprintf ( fichier_qif,
					    "$%s\n",
					    montant_tmp );

				}

			      liste_ventil = liste_ventil -> next;
			    }
			}
		      else
			{
			  if ( operation -> relation_no_operation )
			    {
			      /* c'est un virement */

			      gpointer **save_ptab;

			      save_ptab = p_tab_nom_de_compte_variable;

			      p_tab_nom_de_compte_variable = p_tab_nom_de_compte + operation -> relation_no_compte;

			      fprintf ( fichier_qif,
					"L%s\n",
					g_strconcat ( "[",
						      NOM_DU_COMPTE,
						      "]",
						      NULL ));

			      p_tab_nom_de_compte_variable = save_ptab;
			    }
			  else
			    {
			      /* c'est du type categ : sous-categ */
			    
			      pointeur = g_slist_find_custom ( liste_struct_categories,
							       GINT_TO_POINTER ( operation -> categorie ),
							       (GCompareFunc) recherche_categorie_par_no );

			      if ( pointeur )
				{
				  GSList *pointeur_2;
				  struct struct_categ *categorie;

				  categorie = pointeur -> data;

				  pointeur_2 = g_slist_find_custom ( categorie -> liste_sous_categ,
								     GINT_TO_POINTER ( operation -> sous_categorie ),
								     (GCompareFunc) recherche_sous_categorie_par_no );
				  if ( pointeur_2 )
				    fprintf ( fichier_qif,
					      "L%s\n",
					      g_strconcat ( categorie -> nom_categ,
							    ":",
							    ((struct struct_sous_categ *)(pointeur_2->data)) -> nom_sous_categ,
							    NULL ));
				  else
				    fprintf ( fichier_qif,
					      "L%s\n",
					      categorie -> nom_categ );
				}
			    }
			}
		    
		      fprintf ( fichier_qif,
				"^\n" );
		    }

		  pointeur_tmp = pointeur_tmp -> next;
		}
	    }
	  else
	    {
	      /* le compte n'a aucune opration enregistre : on ne met pas de date, mais on fait l'ouverture du compte */

	      /* met le solde initial */

	      montant_tmp = g_strdup_printf ( "%4.2f",
					      SOLDE_INIT );
	      montant_tmp = g_strdelimit ( montant_tmp,
					   ",",
					   '.' );

	      fprintf ( fichier_qif,
			"T%s\n",
			montant_tmp );


	      fprintf ( fichier_qif,
			"CX\nPOpening Balance\n" );

	      /* met le nom du compte */

	      fprintf ( fichier_qif,
			"L%s\n^\n",
			g_strconcat ( "[",
				      NOM_DU_COMPTE,
				      "]",
				      NULL ) );
	    }
	  fclose ( fichier_qif );
	}
      liste_tmp = liste_tmp -> next;
    }



  gnome_dialog_close ( GNOME_DIALOG ( dialog ));

}
/* *******************************************************************************/





/* *******************************************************************************/
void click_compte_export_qif ( GtkWidget *bouton,
			       GtkWidget *entree )
{

  if ( gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON ( bouton ) ) )
    {
      gtk_widget_set_sensitive ( entree,
				 TRUE );
      liste_entrees_exportation = g_slist_append ( liste_entrees_exportation,
						   gnome_file_entry_gtk_entry ( GNOME_FILE_ENTRY ( entree)) );
    }
  else
    {
      gtk_widget_set_sensitive ( entree,
				 FALSE );
      liste_entrees_exportation = g_slist_remove ( liste_entrees_exportation,
						   gnome_file_entry_gtk_entry ( GNOME_FILE_ENTRY ( entree)) );
    }

}
/* *******************************************************************************/

